<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_HotelOptionBookingRules ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_HotelOptionBookingRules extends AbstractStructArrayBase
{
    /**
     * The HotelOption
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_HotelOptionBookingRules[]
     */
    public $HotelOption;
    /**
     * Constructor method for ArrayOfJP_HotelOptionBookingRules
     * @uses ArrayOfJP_HotelOptionBookingRules::setHotelOption()
     * @param \StructType\JP_HotelOptionBookingRules[] $hotelOption
     */
    public function __construct(array $hotelOption = array())
    {
        $this
            ->setHotelOption($hotelOption);
    }
    /**
     * Get HotelOption value
     * @return \StructType\JP_HotelOptionBookingRules[]|null
     */
    public function getHotelOption()
    {
        return $this->HotelOption;
    }
    /**
     * This method is responsible for validating the values passed to the setHotelOption method
     * This method is willingly generated in order to preserve the one-line inline validation within the setHotelOption method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateHotelOptionForArrayConstraintsFromSetHotelOption(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_HotelOptionBookingRulesHotelOptionItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_HotelOptionBookingRulesHotelOptionItem instanceof \StructType\JP_HotelOptionBookingRules) {
                $invalidValues[] = is_object($arrayOfJP_HotelOptionBookingRulesHotelOptionItem) ? get_class($arrayOfJP_HotelOptionBookingRulesHotelOptionItem) : sprintf('%s(%s)', gettype($arrayOfJP_HotelOptionBookingRulesHotelOptionItem), var_export($arrayOfJP_HotelOptionBookingRulesHotelOptionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The HotelOption property can only contain items of type \StructType\JP_HotelOptionBookingRules, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set HotelOption value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_HotelOptionBookingRules[] $hotelOption
     * @return \ArrayType\ArrayOfJP_HotelOptionBookingRules
     */
    public function setHotelOption(array $hotelOption = array())
    {
        // validation for constraint: array
        if ('' !== ($hotelOptionArrayErrorMessage = self::validateHotelOptionForArrayConstraintsFromSetHotelOption($hotelOption))) {
            throw new \InvalidArgumentException($hotelOptionArrayErrorMessage, __LINE__);
        }
        $this->HotelOption = $hotelOption;
        return $this;
    }
    /**
     * Add item to HotelOption value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_HotelOptionBookingRules $item
     * @return \ArrayType\ArrayOfJP_HotelOptionBookingRules
     */
    public function addToHotelOption(\StructType\JP_HotelOptionBookingRules $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_HotelOptionBookingRules) {
            throw new \InvalidArgumentException(sprintf('The HotelOption property can only contain items of type \StructType\JP_HotelOptionBookingRules, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->HotelOption[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_HotelOptionBookingRules|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_HotelOptionBookingRules|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_HotelOptionBookingRules|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_HotelOptionBookingRules|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_HotelOptionBookingRules|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string HotelOption
     */
    public function getAttributeName()
    {
        return 'HotelOption';
    }
}
